package mario;

import java.awt.*;

public abstract class AbstractPlatform extends WorldObject {

  public boolean deadly;
  public boolean supportsMario;
  public Color color = Palette.PLATFORM;

  public AbstractPlatform() {
    main = Main.main;
    g = main.g;
    playingMode = Main.playingMode;
  }

  public abstract void move();

  @Override
  public void update() {

    int x1 = x;
    int y1 = y;

    supportsMario = playingMode.mario.supportedBy(this);

    move();

    boolean remove2 = remove;
    int x2 = x;
    int y2 = y;

    x = x1;
    y = y1;
    remove = false;
    
    platformTranslateY(y2);
    platformTranslateX(x2);

    remove = remove2;
  }

  public void platformTranslateX(int x2) {

    while(x < x2) {
      boolean holdingMario = playingMode.mario.supportedBy(this);
      x++;
      if (holdingMario || intersects(playingMode.mario)) {
        remove = true;
        playingMode.mario.translateX(1, true);
        remove = false;
      }
    }

    while(x > x2) {
      boolean holdingMario = playingMode.mario.supportedBy(this);
      x--;
      if (holdingMario || intersects(playingMode.mario)) {
        remove = true;
        playingMode.mario.translateX(-1, true);
        remove = false;
      }
    }
  }

  public void platformTranslateY(int y2) {

    while(y < y2) {
      boolean holdingMario = playingMode.mario.supportedBy(this);
      y++;
      if (holdingMario || intersects(playingMode.mario)) {
        remove = true;
        playingMode.mario.translateY(1, true);
        remove = false;
      }
    }

    while(y > y2) {
      boolean holdingMario = playingMode.mario.supportedBy(this);
      y--;
      if (holdingMario || intersects(playingMode.mario)) {
        remove = true;
        playingMode.mario.translateY(-1, true);
        remove = false;
      }
    }
  }

  @Override
  public void render() {
    g.setColor(color);
    g.translate(x - playingMode.cameraX, y);
    g.drawRect(bx1, by1, bx2, by2);
    g.translate(playingMode.cameraX - x, -y);
  }
}
