package mario;

public class Axe extends WorldObject {

  public Axe(int x, int y, boolean mapCoordinates) {

    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;

    bx1 = mx1 = 5;
    by1 = my1 = 0;
    bx2 = mx2 = 21;
    by2 = my2 = 31;
  }

  @Override
  public void update() {
    if (intersects(playingMode.mario, true)) {
      playingMode.hitAxe(x >> 5, y >> 5);
    }
  }

  @Override
  public void render() {
    g.translate(x - playingMode.cameraX, y);
    g.setColor(playingMode.questionmarkColors[
        playingMode.questionmarkColorsIndex]);
    g.drawArc(0, -5, 31, 31, 135, 90);
    g.drawArc(0, -5, 31, 31, -45, 90);
    g.drawArc(0, -20, 31, 24, 225, 90);
    g.drawArc(0, 17, 31, 24, 45, 90);
    g.setColor(Palette.AXE_HANDLE);
    g.fillRect(14, 2, 4, 30);
    g.translate(playingMode.cameraX - x, -y);
  }

}
