package mario;

import java.awt.*;

public class Bloober extends WorldObject {

  public static final float DECEND_SPEED = 0.75f;
  public static final float ASCEND_SPEED = 2f;

  public int ascendCountdown;
  public int restCountdown;

  public Bloober(int x, int y, boolean mapCoordinates) {
    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;

    supports = false;

    bx1 = mx1 = 0;
    by1 = my1 = 0;
    bx2 = mx2 = 31;
    by2 = my2 = 47;
  }

  @Override
  public void update() {

    if (restCountdown > 0) {
      restCountdown--;
      fy += DECEND_SPEED;
      y = (int)fy;
    } else if (ascendCountdown == 0) {
      if (y < playingMode.mario.y && y < 320) {
        fy += DECEND_SPEED;
        y = (int)fy;
      } else {
        ascendCountdown = 30;
        if (x < playingMode.mario.x) {
          vx = ASCEND_SPEED;
        } else {
          vx = -ASCEND_SPEED;
        }
      }
    } else {
      ascendCountdown--;
      if (ascendCountdown == 0) {
        restCountdown = 25;
      }
      fx += vx;
      fy -= ASCEND_SPEED;
      x = (int)fx;
      y = (int)fy;
    }

    if (y < 64) {
      fy = y = 64;
      restCountdown = 25;
      ascendCountdown = 0;
    }

    if (x < playingMode.cameraX - 256) {
      remove = true;
    }
  }

  @Override
  public boolean blast(int px, int py, boolean left) {
    if (remove) {
      return false;
    }
    if (withinMargin(px, py)) {
      playingMode.others.add(new UpsideDownDeadBloober(x, y, left ? -4 : 4));
      playingMode.addPoints(this, 200);
      remove = true;
      return true;
    }
    return false;
  }

  @Override
  public void starred(boolean left) {
    if (remove) {
      return;
    }
    shelled(left);
    playingMode.addPoints(this, 200);
  }

  @Override
  public void shelled(boolean left) {
    if (remove) {
      return;
    }
    playingMode.others.add(new UpsideDownDeadBloober(x, y, left ? -4 : 4));
    remove = true;
  }

  @Override
  public boolean hurtsMario() {
    return !remove && intersects(playingMode.mario, true);
  }

  @Override
  public void render() {
    g.setColor(Color.WHITE);
    g.translate(x - playingMode.cameraX, y);
    g.drawLine(12, 0, 0, 12);
    g.drawLine(19, 0, 31, 12);
    g.drawLine(13, 0, 18, 0);
    g.drawLine(14, 0, 5, 12);
    g.drawLine(17, 0, 26, 12);
    g.drawLine(0, 12, 31, 12);
    g.drawLine(5, 13, 5, 25);
    g.drawLine(26, 13, 26, 25);
    g.drawLine(2, 26, 29, 26);
    g.drawLine(7, 45, 7, 27);
    g.drawLine(24, 45, 24, 27);
    g.drawLine(13, 47, 13, 27);
    g.drawLine(18, 47, 18, 27);
    g.translate(playingMode.cameraX - x, -y);
  }
}
