package mario;

public class BulletBill extends WorldObject {

  public boolean fromCannon;
  public int cannonX;
  public int cannonY;

  public BulletBill(int x, int y, boolean mapCoordinates, float vx,
      boolean fromCannon, int cannonX, int cannonY) {
    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }
    this.fx = this.x = x;
    this.fy = this.y = y;
    this.vx = vx;
    this.fromCannon = fromCannon;
    this.cannonX = cannonX;
    this.cannonY = cannonY;
  }

  @Override
  public void update() {

    fx += vx;
    x = (int)fx;

    if (vx < 0) {
      if (x + 32 < playingMode.cameraX) {
        remove = true;
      }
    } else if (x > playingMode.cameraX + 544) {
      remove = true;
    }
  }

  @Override
  public boolean blast(int px, int py, boolean left) {
    return withinMargin(px, py);
  }

  @Override
  public void starred(boolean left) {
    shelled(left);
    playingMode.addPoints(this, 200);
  }

  @Override
  public void shelled(boolean left) {
    playingMode.others.add(new UpsideDownDeadBulletBill(x, y, vx));
    remove = true;
  }

  @Override
  public void crush() {
    playingMode.others.add(new UpsideDownDeadBulletBill(x, y, vx));
    remove = true;
    playingMode.addStompPoints(this);
  }

  @Override
  public boolean hurtsMario() {
    return !remove && intersects(playingMode.mario, true);
  }

  @Override
  public void render() {
    g.setColor(Palette.TURTLE_CANNON);
    g.translate(x - playingMode.cameraX, y);    
    if (vx < 0) {
      boolean clip = fromCannon && cannonX - x < 32;
      if (clip) {
        g.setClip(0, 0, cannonX - x, 31);
      }
      g.drawLine(31, 2, 31, 29);
      g.drawLine(12, 2, 30, 2);
      g.drawLine(12, 29, 30, 29);
      g.drawArc(0, 2, 30, 27, 90, 180);
      if (clip) {
        g.setClip(null);
      }
    } else {
      boolean clip = fromCannon && x - cannonX < 32;
      if (clip) {
        g.setClip(cannonX - x + 32, 0, 63, 31);
      }
      g.drawLine(0, 2, 0, 29);
      g.drawLine(19, 2, 1, 2);
      g.drawLine(19, 29, 1, 29);
      g.drawArc(1, 2, 30, 27, -90, 180);
      if (clip) {
        g.setClip(null);
      }
    }
    g.translate(playingMode.cameraX - x, -y);
  }
}
