package mario;

public class CheepCheepSpawner extends WorldObject {

  public int available = 3;
  public int delay;

  public CheepCheepSpawner() {
  }

  @Override
  public void update() {
    if (delay > 0) {
      delay--;
    } else if (available > 0) {
      resetDelay(random.nextBoolean());
      createCheepCheep();
    }
  }
  
  private void createCheepCheep() {
    available--;
    if (playingMode.cameraX < playingMode.maxCameraX - 256) {
      playingMode.enemies.add(new CheepCheep(this));
    }
  }

  private void resetDelay(boolean shot) {
    if (shot) {
      delay = 60 + random.nextInt(60);
    } else {
      delay = 30 + random.nextInt(30);
    }
  }

  public void killed(boolean shot) {
    available++;
    resetDelay(shot);
  }

  @Override
  public void render() {
  }
}
