package mario;

public class CoinPlatform extends AbstractPlatform {

  public static final int STEPS = 16;
  public static final float INCREMENT = (float)(Math.PI / STEPS);
  public static final float RADIUS = 8;

  public int mapX;
  public int mapY;
  public float t;
  public int steps = STEPS;
  public int originY;

  public CoinPlatform(int px, int py) {
    this.mapX = px >> 5;
    this.mapY = py >> 5;
    playingMode.physicsMap[mapY][mapX] = BlockTypes.EMPTY;
    playingMode.displayMap[mapY][mapX] = BlockTypes.EMPTY;
    x = mapX << 5;
    originY = y = mapY << 5;
    deadly = true;

    playingMode.others.add(new FlyingCoin(x, y - 32));
    if (playingMode.valuesMap[mapY][mapX] == 0) {
      playingMode.valuesMap[mapY][mapX] = playingMode.timer;
    }
  }

  @Override
  public void move() {
    if (--steps == 0) {      
      if (playingMode.valuesMap[mapY][mapX] - playingMode.timer > 8) {
        playingMode.physicsMap[mapY][mapX] = BlockTypes.SOLID;
        playingMode.displayMap[mapY][mapX] = BlockTypes.SOLID;
      } else {
        playingMode.physicsMap[mapY][mapX] = BlockTypes.COINS;
        playingMode.displayMap[mapY][mapX] = BlockTypes.BRICK;
      }
      remove = true;
    } else {
      y = (int)(originY - RADIUS * Math.sin(t));
      t += INCREMENT;
    }
  }

  @Override
  public void render() {
    g.setColor(Palette.STONES[playingMode.stoneIndex]);
    g.translate((int)x - playingMode.cameraX, (int)y);
    g.drawRect(0, 0, 31, 31);
    g.translate(playingMode.cameraX - (int)x, -(int)y);
  }
}
