package mario;

public class ElevatorPlatform extends AbstractPlatform {

  public int width;
  public int height;

  public ElevatorPlatform(int x, int y, boolean mapCoordinates,
      int width, int height, float vy) {

    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;
    this.width = width;
    this.height = height;
    this.vy = vy;

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = width - 1;
    my2 = by2 = height - 1;
  }

  @Override
  public void move() {
    fy += vy;
    y = (int)fy;

    if (y + my2 < 0) {
      remove = true;
      playingMode.platforms.add(new ElevatorPlatform(
          x, 479, false, width, height, vy));
    } else if (y >= 480) {
      remove = true;
      playingMode.platforms.add(new ElevatorPlatform(
          x, 1 - my2, false, width, height, vy));
    } else if (x + bx2 < playingMode.cameraX) {
      remove = true;
    }
  }

}
