package mario;

public class Fireball extends WorldObject {

  public static final float SPEED = 6f;
  public boolean bouncing;

  public Fireball(int x, int y, boolean left) {
    playingMode.fireballCount++;
    this.fx = this.x = x;
    this.fy = this.y = y;
    vy = SPEED;
    if (left) {
      vx = -SPEED;
    } else {
      vx = SPEED;
    }

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = 16;
    my2 = by2 = 16;
  }

  public void update() {

    if (x < playingMode.cameraX - 64 || y > 480
        || x > playingMode.cameraX + 576) {
      playingMode.fireballCount--;
      remove = true;
      return;
    }

    if (!translateX(vx, false)) {
      playingMode.fireballCount--;
      remove = true;
    } else if (bouncing) {
      if (applyGravity(false)) {
        vy = -5f;
      }
    } else {
      if (!translateY(vy, false)) {
        bouncing = true;
        vy = -5f;
      }
    }

    for(int i = playingMode.enemies.size() - 1; i >= 0; i--) {
      WorldObject enemy = playingMode.enemies.get(i);
      if (!enemy.remove && enemy.blast(x + 8, y + 8, vx < 0)) {
        playingMode.fireballCount--;
        remove = true;
        return;
      }
    }

    for(int i = playingMode.shells.size() - 1; i >= 0; i--) {
      StaticKoopaShell shell = playingMode.shells.get(i);
      if (!shell.remove && shell.blast(x + 8, y + 8, vx < 0)) {
        playingMode.fireballCount--;
        remove = true;
        return;
      }
    }
  }

  public void render() {
    g.setColor(Palette.FIRE);
    g.translate(x - playingMode.cameraX, y);
    g.drawOval(0, 0, 16, 16);
    g.translate(playingMode.cameraX - x, -y);
  }
}
