package mario;

public class Firebar extends WorldObject {

  public static final float SPEED = (float)(2.0 * Math.PI / (4 * 60));
  public static final float ANGLE = (float)(Math.PI / 2.0);

  public float angle;
  public float speed;
  public int length;
  public int[][] points;

  public Firebar(int x, int y, boolean mapCoordinates, boolean clockwise,
      int length) {

    if (mapCoordinates) {
      x = (x << 5) + 16;
      y = (y << 5) + 16;
    }

    if (clockwise) {
      speed = SPEED;
      angle = ANGLE - random.nextFloat() * 0.5f * ANGLE;
    } else {
      speed = -SPEED;
      angle = -ANGLE + random.nextFloat() * 0.5f * ANGLE;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;
    this.length = length;

    points = new int[length][2];

    my2 = by2 = my1 = by1 = mx2 = bx2 = mx1 = bx1 = 0;
  }

  public void update() {

    float sin = (float)Math.sin(angle);
    float cos = (float)Math.cos(angle);
    float radius = 0;
    for(int i = 0; i < length; i++, radius += 16) {
      int[] point = points[i];
      point[0] = (int)(fx + radius * cos);
      point[1] = (int)(fy + radius * sin);
      if (playingMode.mario.contains(point[0], point[1])) {
        playingMode.mario.die();
      }
    }
    
    angle += speed;

    if (fx + radius + 16 < playingMode.cameraX) {
      remove = true;
    }
  }

  public void render() {
    g.setColor(Palette.FIRE);
    for(int i = 0; i < length; i++) {
      int[] point = points[i];
      g.drawOval(point[0] - playingMode.cameraX - 8, point[1] - 8, 16, 16);
    }
  }

}
