package mario;

public class FireworkStreamer extends WorldObject {

  public static final int LENGTH = 32;
  public static final int SIZE = 3;
  public int[][] ps = new int[LENGTH][2];
  public int head;
  public int paletteIndex;

  public FireworkStreamer(int x, int y, float vx, float vy) {

    this.fx = this.x = x;
    this.fy = this.y = y;
    this.vx = vx;
    this.vy = vy;

    G = 0.0075f;

    for(int i = 0; i < LENGTH; i++) {
      ps[i][0] = x;
      ps[i][1] = y;
    }
  }

  public void update() {
    vy += G;
    fx += vx;
    fy += vy;
    x = (int)fx;
    y = (int)fy;

    int[] p = ps[head];
    if (++head == LENGTH) {
      head = 0;
    }
    p[0] = x;
    p[1] = y;

    if (paletteIndex < Firework.PALETTE.length - 1) {
      paletteIndex++;
    } else {
      remove = true;
      playingMode.flagPoleState = PlayingMode.FLAG_POLE_STATE_FIREWORK_DONE;
    }
  }

  public void render() {
    g.setColor(Firework.PALETTE[paletteIndex]);
    for(int i = 0; i < LENGTH; i++) {
      int[] p = ps[i];
      g.fillOval(p[0] - playingMode.cameraX, p[1], SIZE, SIZE);
    }
  }
}
