package mario;

import java.awt.Color;

public class Flower extends WorldObject {

  public int rising = 32;
  public int colorIndex;
  public int colorIndexIncrementor;

  public Flower(int mapX, int mapY) {
    bx1 = 6;
    by1 = 0;
    bx2 = 17;
    by2 = 31;

    fx = x = mapX << 5;
    fy = y = mapY << 5;
    vx = 1;
  }

  public void update() {

    if (remove) {
      return;
    }

    if (++colorIndexIncrementor == 4) {
      colorIndexIncrementor = 0;
      if (++colorIndex == 4) {
        colorIndex = 0;
      }
    }

    if (rising > 0) {
      rising--;
      fy--;
      y = (int)fy;
    } else {
      if (x < playingMode.cameraX - 512 || y > 480) {
        remove = true;
      }

      if (playingMode.mario.intersects(this)) {
        consume();
      }
    }
  }

  private void consume() {
    remove = true;
    playingMode.addPoints(this, 1000);
    playingMode.mario.collectFlower();
  }

  public void render() {
    g.translate(x - playingMode.cameraX, y);
    if (rising > 0) {
      g.setClip(0, 0, 32, 32 - rising);
    }
    g.setColor(Palette.FLOW_STEM);
    g.drawLine(15, 16, 15, 31);
    g.drawLine(16, 16, 16, 31);
    g.drawLine(0, 19, 15, 31);
    g.drawLine(31, 19, 16, 31);
    Color[] colors = Palette.FLOWER_PEDDLES[colorIndex];
    g.setColor(colors[0]);
    g.drawOval(0, 0, 31, 15);
    g.setColor(colors[1]);
    g.drawOval(4, 4, 23, 7);
    g.setColor(colors[2]);
    g.drawOval(10, 6, 11, 3);
    if (rising > 0) {
      g.setClip(null);
    }
    g.translate(playingMode.cameraX - x, -y);
  }

}

