package mario;

public class FlyingCoin extends WorldObject {

  public static final int[] palette = { 0, 0, 1, 1, 0, 0, 2, 2 };
  public static final float ANGLE_INC = (float)(Math.PI / 8);

  public float angle;
  public int paletteIndex;
  public int coinX;
  public int width;
  public int startY;

  public FlyingCoin(int x, int y) {
    this.fx = this.x = x;
    this.fy = this.startY = this.y = y;
    vy = -9f;
    coinX = 15;
    playingMode.collectCoin(this);
  }

  public void update() {    
    angle += ANGLE_INC;
    if (++paletteIndex == 8) {
      paletteIndex = 0;
    }
    width = Math.abs((int)(8 * Math.sin(angle)));
    coinX = (int)(15 - width);
    width <<= 1;

    vy += G;
    fy += vy;
    y = (int)fy;

    if (y >= startY) {
      remove = true;
      playingMode.addPoints(this, 200);
    }
  }

  public void render() {    
    g.setColor(Palette.FLYING_COINS[palette[paletteIndex]]);
    g.translate(x - playingMode.cameraX, y);
    g.drawOval(coinX, 4, width, 28);
    g.translate(playingMode.cameraX - x, -y);
  }
}
