package mario;

import java.awt.geom.*;
import java.awt.*;

public class Hammer extends WorldObject {

  public static float ANGLE_SPEED = 0.2f;

  public AffineTransform originalTransform;
  public float angle;

  public Hammer(int x, int y, float vx, float vy) {
    
    this.fx = this.x = x;
    this.fy = this.y = y;
    this.vx = vx;
    this.vy = vy;

    supports = false;

    originalTransform = ((Graphics2D)g).getTransform();

    G = 0.25f;
  }

  @Override
  public void update() {

    if (y > 480 || x + 32 < playingMode.cameraX) {
      remove = true;
    }

    if (vx < 0) {
      angle -= ANGLE_SPEED;
    } else {
      angle += ANGLE_SPEED;
    }

    vy += G;
    fy += vy;
    y = (int)fy;
    
    fx += vx;
    x = (int)fx;

    if (playingMode.mario.contains(x + 16, y + 16)) {
      playingMode.mario.die();
    }  
  }

  @Override
  public void render() {

    g.setColor(Palette.HAMMER);
    g.translate(x - playingMode.cameraX, y);
    ((Graphics2D)g).rotate(angle, 16, 16);
    g.drawLine(15, 0, 15, 15);
    g.drawLine(16, 0, 16, 15);
    g.drawLine(15, 28, 15, 31);
    g.drawLine(16, 28, 16, 31);
    g.drawLine(9, 16, 22, 16);
    g.drawLine(9, 27, 22, 27);
    g.drawLine(9, 17, 9, 26);
    g.drawLine(22, 17, 22, 26);
    ((Graphics2D)g).setTransform(originalTransform);
  }

}
