package mario;

import java.io.*;

public class InputRecorder {

  public static final String FILE_NAME = "1-3.dat";
  public static final int SECONDS = 30;

  public byte[] recordedValues = new byte[SECONDS * 60];
  public int recordingIndex;

  public void record(boolean isUp, boolean isDown, boolean isLeft,
      boolean isRight, boolean isRun, boolean isJump) {

    int value = 0;
    if (isUp) {
      value |= 1;
    }
    if (isDown) {
      value |= 2;
    }
    if (isLeft) {
      value |= 4;
    }
    if (isRight) {
      value |= 8;
    }
    if (isRun) {
      value |= 16;
    }
    if (isJump) {
      value |= 32;
    }
    recordedValues[recordingIndex++] = (byte)value;
    if (recordingIndex == recordedValues.length) {
      saveRecording();
    }
  }

  private void saveRecording() {
    try {
      FileOutputStream out = new FileOutputStream(FILE_NAME);
      out.write(recordedValues);
      out.close();
    } catch(Throwable t) {
      t.printStackTrace();
    }
    System.exit(0);
  }
}
