package mario;

public class Maze extends WorldObject {

  public int world;
  public boolean maze4CopiedPage1;
  public boolean maze4CopiedPage2;
  public boolean wrongWay;
  public boolean maze7CopiedPage1;
  public boolean maze7CopiedPage2;
  public boolean maze8CopiedPage1;
  public boolean maze8CopiedPage2;

  public Maze(int world) {    
    this.world = world;

    switch(world) {
      case 4:
        playingMode.cameraX = 512;
        break;
    }
  }

  @Override
  public void update() {
    switch(world) {
      case 4:
        updateMaze4();
        break;
      case 7:
        updateMaze7();
        break;
      case 8:
        updateMaze8();
        break;
    }
  }

  private void updateMaze4() {
    if (!maze4CopiedPage1 && playingMode.cameraX > 1024) {
      copyPage(5, 1);
      maze4CopiedPage1 = true;
    }
    if (!maze4CopiedPage2 && playingMode.cameraX > 3072) {
      copy2Pages(8, 4);
      maze4CopiedPage2 = true;
    }
    if (wrongWay) {
      if (playingMode.cameraX > 2560 && playingMode.cameraX < 2592) {
        jumpBack(4);
      } else if (playingMode.cameraX > 4096 && playingMode.cameraX < 4128) {
        jumpBack(4);
      }
    }
  }

  private void updateMaze7() {
    if (!maze7CopiedPage1 && playingMode.cameraX > 1024) {
      copy2Pages(4, 0);
      maze7CopiedPage1 = true;
    }
    if (!maze7CopiedPage2 && playingMode.cameraX > 3072) {
      copy2Pages(8, 4);
      maze7CopiedPage2 = true;
    }
    if (wrongWay) {
      if (playingMode.cameraX > 2592 && playingMode.cameraX < 2624) {
        jumpBack(4);
      } else if (playingMode.cameraX > 4640 && playingMode.cameraX < 4672) {
        jumpBack(4);
      }
    }
  }

  private void updateMaze8() {
    if (playingMode.cameraX > 3072 && playingMode.cameraX < 3104) {
      jumpBack(4);
    }
    if (playingMode.cameraX > 5632 && playingMode.cameraX < 5664) {
      jumpBack(4);
    }
    if (playingMode.cameraX > 8192 && playingMode.cameraX < 8224) {
      jumpBack(4);
    }
  }

  private void jumpBack(int pages) {

    int dx = pages << 9;

    playingMode.mario.x -= dx;
    playingMode.mario.fx = playingMode.mario.x;
    playingMode.cameraX -= dx;
    playingMode.enemiesMapX -= pages << 4;
    for(int i = playingMode.enemies.size() - 1; i >= 0; i--) {
      WorldObject enemy = playingMode.enemies.get(i);
      enemy.x -= dx;
      enemy.fx = enemy.x;
    }
    for(int i = playingMode.items.size() - 1; i >= 0; i--) {
      WorldObject item = playingMode.items.get(i);
      item.x -= dx;
      item.fx = item.x;
    }
    wrongWay = false;
    playingMode.spittingFire = false;
  }

  private void copyPage(int sourcePage, int destinationPage) {
    int sourceX = sourcePage << 4;
    int destinationX = destinationPage << 4;
    for(int i = 0; i < 15; i++) {
      System.arraycopy(playingMode.displayMap[i], sourceX,
          playingMode.displayMap[i], destinationX, 16);
      System.arraycopy(playingMode.physicsMap[i], sourceX,
          playingMode.physicsMap[i], destinationX, 16);
    }
  }

  private void copy2Pages(int sourcePage, int destinationPage) {
    int sourceX = sourcePage << 4;
    int destinationX = destinationPage << 4;
    for(int i = 0; i < 15; i++) {
      System.arraycopy(playingMode.displayMap[i], sourceX,
          playingMode.displayMap[i], destinationX, 32);
      System.arraycopy(playingMode.physicsMap[i], sourceX,
          playingMode.physicsMap[i], destinationX, 32);
    }
  }

  public void wentWrongWay() {
    wrongWay = true;
  }

  @Override
  public void render() {
  }
}
