package mario;

public class Podoboo extends WorldObject {

  public static final float GRAVITY = 0.15f;
  public static final float[] VELOCITIES = new float[32];

  public boolean moving;
  public int delay;

  static {
    int index = -1;
    float y = 0;
    float vy = 0;
    while(true) {
      int index2 = ((int)y) >> 5;
      if (index2 > index) {
        index = index2;
        if (index >= VELOCITIES.length) {
          break;
        } else {
          VELOCITIES[index] = vy;
        }
      }
      vy += GRAVITY;
      y += vy;
    }
  }

  public Podoboo(int mapX) {

    supports = false;

    this.fx = this.x = mapX << 5;
    this.fy = this.y = 480;
  }

  public void update() {

    if (x + 32 < playingMode.cameraX) {
      remove = true;
      return;
    }

    if (moving) {
      if (vy > 0 && y > 480) {
        moving = false;
        delay = random.nextInt(3) * 60;        
      } else {
        vy += GRAVITY;
        fy += vy;
        y = (int)fy;
      }
    } else if (delay > 0) {
      delay--;
    } else {
      moving = true;
      this.fy = this.y = 480;
      int height = playingMode.mario.y;
      if (height < 0) {
        height = 0;
      }
      height = (height >> 5) - random.nextInt(4);
      if (height < 5) {
        height = 5;
      }
      int index = 14 - (height - 1);
      if (index < 0) {
        index = 0;
      } else if (index >= VELOCITIES.length) {
        index = 16;
      }
      vy = -VELOCITIES[index];
    }
  }

  @Override
  public boolean blast(int px, int py, boolean left) {
    if (withinMargin(px, py)) {
      return true;
    }
    return false;
  }

  @Override
  public boolean hurtsMario() {
    return !remove && intersects(playingMode.mario, true);
  }

  public void render() {
    g.translate(x - playingMode.cameraX, y);
    g.setColor(Palette.SPIT_FIRES[0]);
    g.drawOval(0, 0, 31, 31);
    g.setColor(Palette.SPIT_FIRES[1]);
    g.drawOval(5, 5, 21, 21);
    g.setColor(Palette.SPIT_FIRES[2]);
    g.drawOval(11, 11, 9, 9);
    g.translate(playingMode.cameraX - x, -y);
  }
}
