package mario;

import java.awt.*;

public class Points extends WorldObject {

  public static final int MAX_COUNT = 60;

  public String label;
  public int count;
  public int size;
  public int padding;

  public Points(WorldObject object, int points) {
    this(object, Integer.toString(points));
    playingMode.score += points;
  }

  public Points(WorldObject object, String label) {
    this(object, label, 7, 2);
  }

  public Points(WorldObject object, String label, int size, int padding) {

    int X = ((object.x + ((object.mx2 - object.mx1 + 1) >> 1)) - 16);

    this.fx = this.x = X + (label.length() < 4 ? 3 : -3);
    this.fy = this.y = object.y + object.by1
        + ((object.by2 - object.by1 - 7) >> 1);
    this.label = label;
    this.size = size;
    this.padding = padding;
  }

  public void update() {
    if (++count >= MAX_COUNT) {
      remove = true;
    } else {
      fy -= 0.75;
      y = (int)fy;
    }
  }

  public void render() {
    g.setColor(Color.WHITE);
    g.translate(x - playingMode.cameraX, y);
    Text.drawString(0, 0, label, size, padding);
    g.translate(playingMode.cameraX - x, -y);
  }
}
