package mario;

public class ReciprocatingPlatform extends AbstractPlatform {

  public static final float ANGLE_INCREMENT = (float)(2.0 * Math.PI / (6 * 60));

  public boolean horizontal;
  public int width;
  public int height;
  public float radius;
  public float center;
  public float angle;

  public ReciprocatingPlatform(
      int a1, int a2, int b, boolean mapCoordinates, boolean horizontal,
      int width, int height) {

    if (mapCoordinates) {
      a1 <<= 5;
      a2 <<= 5;
      b <<= 5;
    }

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = width - 1;
    my2 = by2 = height - 1;

    this.horizontal = horizontal;
    this.width = width;
    this.height = height;

    radius = (a2 - a1) / 2f;
    center = (a2 + a1) / 2f;

    if (horizontal) {
      fy = y = b;
    } else {
      fx = x = b;
    }

    move();
  }

  @Override
  public void move() {

    if (horizontal) {
      fx = center + radius * (float)Math.sin(angle);
      x = (int)fx;
      if (center + radius + width < playingMode.cameraX) {
        remove = true;
      }
    } else {
      fy = center + radius * (float)Math.sin(angle);
      y = (int)fy;
      if (x + width < playingMode.cameraX) {
        remove = true;
      }
    }
    
    angle += ANGLE_INCREMENT;
  }
}
