package mario;

public class ScalePlatform extends AbstractPlatform {

  public static final float MAX_SPEED = 4f;
  public static final float ACCELERATION = 0.05f;
  public static final float SLOW_ACCELERATION = 1.5f * ACCELERATION;

  public ScalePlatform otherScalePlatform;
  public int width;
  public int height;
  public int maxY;
  public boolean broken;
  public int brokeY;
  public int requestedDy;

  public ScalePlatform(int x, int y, int width, int height, int maxY) {

    this.fx = this.x = x;
    this.fy = this.y = y;
    this.width = width;
    this.height = height;
    this.maxY = maxY;

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = width - 1;
    my2 = by2 = height - 1;    
  }

  @Override
  public void move() {

    if (requestedDy != 0) {
      y += requestedDy;
      if (y <= maxY) {
        y = maxY;
        broken = true;
        brokeY = y;
      }
      fy = y;
      requestedDy = 0;
      vy = 0;
      return;
    }

    if (broken) {
      vy += ACCELERATION;
      fy += vy;
      y = (int)fy;
      if (x + bx2 < playingMode.cameraX || y > 544) {
        remove = true;
      }
      return;
    }

    if (supportsMario) {
      vy += ACCELERATION;
    } else if (vy > SLOW_ACCELERATION) {
      vy -= SLOW_ACCELERATION;
    } else {
      vy = 0;
    }

    fy += vy;
    int oldY = y;
    y = (int)fy;

    int dy = y - oldY;
    if (dy != 0) {
      otherScalePlatform.requestMoveY(-dy);
      if (otherScalePlatform.y - dy <= maxY) {
        broken = true;
        brokeY = y;
        playingMode.addPoints(this, 1000);
      }
    }

    if (x + bx2 < playingMode.cameraX || y > 544) {
      remove = true;
    }
  }

  public void requestMoveY(int dy) {
    this.requestedDy = dy;
  }
}
