package mario;

import java.awt.*;

public class SkyLiftPlatform extends AbstractPlatform {

  public static final float SPEED = 2f;

  public SkyLiftPlatform(int x, int y, boolean mapCoordinates,
      int width, int height) {

    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;

    color = Color.WHITE;

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = width - 1;
    my2 = by2 = height - 1;
  }

  @Override
  public void move() {
    if (supportsMario) {
      vx = SPEED;
    }

    fx += vx;
    x = (int)fx;

    if (x > playingMode.maxCameraX + 576) {
      remove = true;
    }
  }
}
