package mario;

public class SpitFire extends WorldObject {

  public static final float SPEED = 2;

  public SpitFire(int x, int y) {
    this.fx = this.x = x;
    this.fy = this.y = y;
    supports = false;

    mx1 = bx1 = 0;
    my1 = by1 = 0;
    mx2 = bx2 = 47;
    my2 = by2 = 15;
  }

  @Override
  public void update() {

    fx -= SPEED;
    x = (int)fx;

    if (x + bx2 < playingMode.cameraX) {
      remove = true;
    }
  }

  @Override
  public boolean blast(int px, int py, boolean left) {
    return withinMargin(px, py);
  }

  @Override
  public boolean hurtsMario() {
    return !remove && intersects(playingMode.mario, true);
  }

  @Override
  public void render() {    
    g.translate(x - playingMode.cameraX, y);
    g.setColor(Palette.SPIT_FIRES[0]);
    g.drawOval(0, 0, 47, 15);
    g.setColor(Palette.SPIT_FIRES[1]);
    g.drawOval(16, 3, 29, 9);
    g.setColor(Palette.SPIT_FIRES[2]);
    g.drawOval(36, 6, 7, 3);
    g.translate(playingMode.cameraX - x, -y);
  }

}
