package mario;

public class Starman extends WorldObject {

  public int rising = 32;
  public int colorIndex;
  public int colorIndexIncrementor;

  public Starman(int mapX, int mapY) {

    G = 0.3f;

    fx = x = mapX << 5;
    fy = y = mapY << 5;

    mx1 = 0;
    my1 = 0;
    mx2 = 31;
    my2 = 31;

    bx1 = 0;
    by1 = 9;
    bx2 = 31;
    by2 = 31;

    vx = 2;
    vy = -6.5f;
  }

  public void update() {

    if (remove) {
      return;
    }

    if (++colorIndexIncrementor == 3) {
      colorIndexIncrementor = 0;
      if (++colorIndex == 3) {
        colorIndex = 0;
      }
    }

    if (rising > 0) {
      rising--;
      fy--;
      y = (int)fy;
    } else {

      if (applyGravity(true)) {
        vy = -6.5f;
      }

      if (!translateX(vx, true)) {
        vx = -vx;
      }

      if (x < playingMode.cameraX - 64
          || x > playingMode.cameraX + 576 || y > 480) {
        remove = true;
      }

      if (playingMode.mario.intersects(this)) {
        consume();
      }
    }
  }

  private void consume() {
    remove = true;
    playingMode.addPoints(this, 1000);
    playingMode.mario.collectStar();
  }

  public void render() {
    g.setColor(Palette.STARS[colorIndex]);
    g.translate(x - playingMode.cameraX, y);
    if (rising > 0) {
      g.setClip(0, 0, 32, 32 - rising);
    }
    g.drawLine(15, 0, 10, 9);
    g.drawLine(10, 9, 2, 9);
    g.drawLine(2, 9, 8, 20);
    g.drawLine(8, 20, 5, 31);
    g.drawLine(5, 31, 15, 25);

    g.drawLine(16, 0, 21, 9);
    g.drawLine(21, 9, 29, 9);
    g.drawLine(29, 9, 23, 20);
    g.drawLine(23, 20, 26, 31);
    g.drawLine(26, 31, 16, 25);
    if (rising > 0) {
      g.setClip(null);
    }
    g.translate(playingMode.cameraX - x, -y);
  }
}
