package mario;

public class TurtleCannon extends WorldObject {

  public static final float BULLET_SPEED = 3;

  public int fireDelay;

  public TurtleCannon(int x, int y, boolean mapCoordinates) {

    if (mapCoordinates) {
      x <<= 5;
      y <<= 5;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;

    fireDelay = 60 + random.nextInt(60);
  }

  @Override
  public void update() {

    if (x + 32 < playingMode.cameraX) {
      remove = true;
      return;
    }

    if (fireDelay > 0) {
      if (playingMode.mario.x < x) {
        if (playingMode.mario.x < x - 64) {
          fireDelay--;
        }
      } else {
        if (playingMode.mario.x > x + 96) {
          fireDelay--;
        }
      }
    } else {
      playingMode.enemies.add(new BulletBill(x, y, false,
          playingMode.mario.x < x ? -BULLET_SPEED : BULLET_SPEED, true, x, y));
      randomizeFireDelay();
    }
  }

  private void randomizeFireDelay() {
    fireDelay = 120 + random.nextInt(180);
  }

  @Override
  public void render() {
  }
}
