package mario;

import java.awt.*;

public class UpsideDownDeadKoopaTroopa extends WorldObject {

  public Color color;

  public UpsideDownDeadKoopaTroopa(int x, int y, float vx, int type) {
    this.fx = this.x = x;
    this.fy = this.y = y;
    this.vx = vx;
    this.vy = -8;
    switch(type) {
      case KoopaTroopaTypes.GREEN:
        color = Palette.GREEN_KOOPA_TROOPA;
        break;
      case KoopaTroopaTypes.RED:
        color = Palette.RED_KOOPA_TROOPA;
        break;
      case KoopaTroopaTypes.BUZZY_BEETLE:
        color = Palette.BUZZY_BEETLE;
        break;
    }
  }

  public void update() {
    fx += vx;
    x = (int)fx;
    vy += G;
    fy += vy;
    if (fy > 512) {
      remove = true;
    }
    y = (int)fy;
  }

  public void render() {
    g.translate(x - playingMode.cameraX, y);
    g.setColor(Palette.KOOPA_TROOPA_LEG);
    g.drawLine(3, 14, 3, 0);
    g.drawLine(28, 14, 28, 0);
    g.drawLine(3, 0, 12, 0);
    g.drawLine(12, 4, 12, 0);
    g.drawLine(19, 4, 19, 0);
    g.drawLine(19, 0, 28, 0);
    g.setColor(color);
    g.drawArc(2, 1, 27, 30, 0, -180);
    g.setColor(Color.WHITE);
    g.drawLine(0, 15, 5, 15);
    g.drawLine(26, 15, 31, 15);
    g.drawArc(5, 4, 21, 20, 0, 180);
    g.translate(playingMode.cameraX - x, -y);
  }
}
