package mario;

import java.awt.geom.*;
import java.awt.*;

public class UpsideDownDeadSpiny extends WorldObject {

  public AffineTransform originalTransform;

  public UpsideDownDeadSpiny(int x, int y, float vx, float vy) {
    this.fx = this.x = x;
    this.fy = this.y = y;
    this.vx = vx;
    this.vy = vy;

    originalTransform = ((Graphics2D)g).getTransform();
  }

  public void update() {
    fx += vx;
    x = (int)fx;
    vy += G;
    fy += vy;
    if (fy > 512) {
      remove = true;
    }
    y = (int)fy;
  }

  public void render() {
    g.translate(x - playingMode.cameraX, y);
    ((Graphics2D)g).rotate(Math.PI, 16, 16);
    g.setColor(Palette.KOOPA_TROOPA_LEG);
    g.drawLine(3, 17, 3, 31);
    g.drawLine(28, 17, 28, 31);
    g.drawLine(3, 31, 12, 31);
    g.drawLine(12, 27, 12, 31);
    g.drawLine(19, 27, 19, 31);
    g.drawLine(19, 31, 28, 31);
    g.setColor(Palette.SPINY_SPIKES);
    g.drawLine(16, 0, 11, 6);
    g.drawLine(4, 10, 0, 8);
    g.drawLine(0, 8, 2, 15);
    g.drawLine(4, 0, 4, 10);
    g.drawLine(4, 0, 11, 6);
    g.drawLine(27, 10, 31, 8);
    g.drawLine(31, 8, 29, 15);
    g.drawLine(27, 0, 27, 10);
    g.drawLine(27, 0, 20, 6);
    g.drawLine(16, 0, 20, 6);
    g.setColor(Palette.SPINY_SHELL);
    g.drawArc(2, 7, 27, 15, 0, 180);
    g.setColor(Color.WHITE);
    g.drawLine(0, 16, 5, 16);
    g.drawLine(26, 16, 31, 16);
    g.drawArc(5, 7, 21, 20, 0, -180);
    ((Graphics2D)g).setTransform(originalTransform);
  }
}
