package mario;

public class Vine extends WorldObject {

  public int bottomY;
  public boolean entryVine;

  public Vine(int x, int y, boolean mapCoordinates, boolean entryVine) {

    if (mapCoordinates) {
      y--;
      x <<= 5;
      y <<= 5;
      y += 32;
    }

    this.fx = this.x = x;
    this.fy = this.y = y;

    mx1 = bx1 = 0;
    mx2 = bx2 = 31;

    bottomY = y;
    my1 = by1 = 0;
    my2 = by2 = bottomY - y;

    this.entryVine = entryVine;
  }

  @Override
  public void update() {
    if ((!entryVine && y > -32) || (entryVine && y > 288)) {
      fy = --y;
      my1 = by1 = 0;
      my2 = by2 = bottomY - y;
    }
    if (playingMode.mario.intersects(this, true)) {
      playingMode.mario.onVine = true;
    }

    Mario mario = playingMode.mario;
    if (y <= 288 && entryVine && mario.vining) {      
      if (mario.y > 320) {
        mario.translateY(-2, true);
      } else if (mario.onVine) {
        mario.translateX(2, true);
      } else {
        mario.vining = false;
        playingMode.physicsMap[13][4] = BlockTypes.SOLID;
      }
    }
  }

  @Override
  public void render() {
    g.setColor(Palette.VINE);
    g.translate(x - playingMode.cameraX, y);
    int height = bottomY - y;
    g.fillRect(14, 0, 4, height);
    boolean left = true;
    for(int i = 0; i < height; i += 16, left = !left) {
      if (left) {
        g.drawLine(0, i, 13, i);
      } else {
        g.drawLine(18, i, 31, i);
      }
    }
    g.translate(playingMode.cameraX - x, -y);
  }
}
