package mario;

import java.awt.*;

public class WorldTitleMode implements IMode {

  public Main main;
  public Graphics g;
  public Color[] questionmarkColors = new Color[64];
  public int questionmarkColorsIndex;
  public int score;
  public int coins;
  public int lives;
  public int world;
  public int subworld;
  public Color color;
  public int countdown = 2 * 60;
  public String name;

  public WorldTitleMode(
      int score, int coins, int lives, int world, int subworld) {
    main = Main.main;
    g = main.g;
    this.score = score;
    this.coins = coins;
    this.lives = lives;
    this.world = world;
    this.subworld = subworld;

    for(int i = 0; i < questionmarkColors.length; i++) {
      double v = Math.sin(Math.PI * i / (double)questionmarkColors.length);
      questionmarkColors[i] = Palette.QUESTIONMARKS[0];
      if (v < 0.3) {
        questionmarkColors[i] = Palette.QUESTIONMARKS[2];
      } else if (v < 0.6) {
        questionmarkColors[i] = Palette.QUESTIONMARKS[1];
      }
    }
  }

  @Override
  public void init() {
    if (main.luigiMode) {
      color = Palette.LUIGI;
      name = "LUIGI";
    } else {
      color = Palette.MARIO;
      name = "MARIO";
    }
  }

  @Override
  public void update() {
    if (++questionmarkColorsIndex == 64) {
      questionmarkColorsIndex = 0;
    }
    if (--countdown <= 0) {
      main.worldTitleModeComplete();
    }
  }

  @Override
  public void render() {

    g.setColor(Color.BLACK);
    g.fillRect(0, 0, 512, 480);

    g.setColor(Color.WHITE);
    Text.drawString(48, 32, name);
    Text.drawNumber(48, 48, score, 6);
    Text.drawChar(192, 48, '~');
    Text.drawNumber(208, 48, coins, 2);
    Text.drawString(288, 32, "WORLD");
    Text.drawNumber(304, 48, world, 1);
    Text.drawChar(320, 48, '-');
    Text.drawNumber(336, 48, subworld, 1);
    Text.drawString(400, 32, "TIME");

    Text.drawString(176, 160, "WORLD");
    Text.drawNumber(272, 160, world, 1);
    Text.drawChar(288, 160, '-');
    Text.drawNumber(304, 160, subworld, 1);

    Text.drawChar(240, 224, '~');
    Text.drawNumberHiddenLeading(272, 224, lives, 2);

    g.setColor(questionmarkColors[questionmarkColorsIndex]);
    g.drawOval(180, 48, 8, 14);

    g.setColor(color);
    g.translate(192, 212);
    g.drawOval(2, 0, 27, 11);
    g.drawLine(15, 12, 15, 22);
    g.drawLine(16, 12, 16, 22);
    g.drawLine(15, 22, 0, 31);
    g.drawLine(16, 22, 31, 31);
    g.drawLine(15, 13, 0, 20);
    g.drawLine(16, 13, 31, 20);
    g.translate(-192, -212);
  }
}
